import gtk
import sys
import urllib2
from koji_downloader import RPMFilter

def col1_toggled_cb(cell, path, model ):
    """
    Sets the toggled state on the toggle button to true or false.
    """
    model[path][1] = not model[path][1]
    model[path][3] = not model[path][3]
    print "Toggle '%s' to: %s" % (model[path][0], model[path][1],)
    return

if __name__ == "__main__":
    builder = gtk.Builder()
    builder.add_from_file("downloader.GtkBuilder")
    window = builder.get_object("main_window")
    tvPackages = builder.get_object("tvPackages")
    builder.get_object("bClose").connect("clicked", gtk.main_quit)
    liststore = gtk.ListStore(str, bool, str, 'gboolean')
    #liststore.append(["aaa", False, "#C9C9C9", True])
    #liststore.append(["aaa", True, "#888888", False])
    tvPackages.set_model(liststore)
    ##
    cell = gtk.CellRendererToggle()
    col = gtk.TreeViewColumn("Download")
    col.pack_start(cell, False)
    cell.set_property('activatable', True)
    cell.connect( 'toggled', col1_toggled_cb, liststore )
    col.set_attributes(cell, active=1,cell_background=2, cell_background_set=3)
    tvPackages.append_column(col)
    ##
    cell = gtk.CellRendererText()
#    cell.set_property('cell-background' , "pink")
    col = gtk.TreeViewColumn("Column 1")
    col.pack_start(cell, False)
    #the first column is always painted
#    cell.set_property('background-set' , False)
#    cell.set_property('foreground-set' , True)
#    col.set_attributes(cell,text=0)
    col.set_attributes(cell, text=0, cell_background=2, cell_background_set=3)
    tvPackages.append_column(col)
    ##HYDRATE
    if len(sys.argv) != 3:
        print "Usage:\n\t%s username task_id [arch]" % sys.argv[0]
    else:
        username = sys.argv[1]
        task_id = sys.argv[2]
        task_url = "http://kojipkgs.fedoraproject.org/scratch/%s/task_%s" % (username, task_id)
        #print task_url
#        url = urllib2.urlopen("http://kojipkgs.fedoraproject.org/scratch/%s/task_%s" % (username, task_id))
#        rpmfilter = RPMFilter()
#        for line in url.readlines():
#            rpmfilter.feed(line)
#        rpm_dict = rpmfilter.get_rpm_dict()
#        for arch, rpms in rpm_dict.iteritems():
#            print "%s:" % arch
            #os.mkdir(arch)
#            for rpm in rpms:
                #f = urllib2.urlopen("%s/%s" % (task_url,rpm))
#                print "\t%s" % rpm
        liststore.append(["aaa", False, "#C9C9C9", True])
        liststore.append(["bbb", False, "#C9C9C9", False])
                #fout = open("%s/%s" % (arch,rpm), "wb")
                #fout.write(f.read())
                #fout.close()
        window.show()
        gtk.main()
